# Copyright (C) 2006, by Miriam Ruiz <little_miry@yahoo.es>
# Distributed under the same license as the game. See debian/copyright.  

diff -ruN holotz-castle-1.3.8.orig/src/HCEnemy.cpp holotz-castle-1.3.8.new/src/HCEnemy.cpp
--- holotz-castle-1.3.8.orig/src/HCEnemy.cpp	2006-01-20 13:59:38.000000000 +0100
+++ holotz-castle-1.3.8.new/src/HCEnemy.cpp	2006-09-23 15:58:27.000000000 +0200
@@ -130,7 +130,9 @@
 
 u32 HCEnemy::Load(JRW &file, HCTheme &theme, HCMap *_map)
 {
-	if (0 == file.ReadLE32((s32 *)&type) ||
+	u32 typeNum;
+
+	if (0 == file.ReadLE32(&typeNum) ||
 			0 == file.ReadLE32(&param1) ||
 			0 == file.ReadLE32(&param2) ||
 			0 != HCCharacter::Load(file))
@@ -141,7 +143,7 @@
 
 	bool ret = false;
 
-	switch (type)
+	switch (typeNum)
 	{
 	default:
 	case HCENEMYTYPE_BALL:
@@ -170,6 +172,8 @@
 		return 2;
 	}
 
+	type = HCEnemyType(typeNum);
+
 	// Adjusts the sprite's framerate according to 1st param
 	for (s32 i = 0; i < HCCS_COUNT; ++i)
 	{
@@ -181,7 +185,9 @@
 
 u32 HCEnemy::Save(JRW &file)
 {
-	if (0 == file.WriteLE32((s32 *)&type) ||
+	u32 typeNum = type;
+
+	if (0 == file.WriteLE32(&typeNum) ||
 			0 == file.WriteLE32(&param1) ||
 			0 == file.WriteLE32(&param2) ||
 			0 != HCCharacter::Save(file))
